<template>
  <div class="pb-[40px] px-4">
    <div class="grid gap-4 grid-cols-1">
      <div v-if="!popularGames.IsHidden" class="statistic">
        <div class="statistic__count bg-default">
          <span>{{ popularGamesCount }}</span>
        </div>
        <div class="statistic__description">
          <h4>{{ $t(popularGames.Text.replace(/ /g, "_").toLowerCase()) }}</h4>
          <nuxt-link class="see-all-link" to="/games/TopGames__n__gt"
            >{{ $t("see_all") }}
            <font-awesome-icon class="ml-4" icon="arrow-right" />
          </nuxt-link>
        </div>
      </div>
      <div v-if="!newGames.IsHidden" class="statistic">
        <div class="statistic__count bg-default">
          <span>{{ newGamesCount }}</span>
        </div>
        <div class="statistic__description">
          <h4>{{ $t(newGames.Text.replace(/ /g, "_").toLowerCase()) }}</h4>
          <nuxt-link class="see-all-link" to="/games/NewGames__n__gt"
            >{{ $t("see_all") }}
            <font-awesome-icon class="ml-4" icon="arrow-right" />
          </nuxt-link>
        </div>
      </div>
      <div v-if="!gameProviders.IsHidden" class="statistic">
        <div class="statistic__count bg-default">
          <span>{{ providers }}</span>
        </div>
        <div class="statistic__description">
          <h4>{{ $t(gameProviders.Text.replace(/ /g, "_").toLowerCase()) }}</h4>
          <div class="see-all-link" @click="dialogVisible = true">
            {{ $t("see_all") }}
            <font-awesome-icon class="ml-4" icon="arrow-right" />
          </div>
        </div>
      </div>
    </div>
    <provider-dialog v-model:dialogVisible="dialogVisible" />
  </div>
</template>

<script lang="ts">
import { computed, defineComponent, ref, PropType } from "vue";
import ProviderDialog from "./provider-dialog.client.vue";
import { store } from "@/store";
import { IThemePropertiesFromApi } from "@/models/companyThemePropertiesRespone";
import { gameStore } from "~~/store/game";

export default defineComponent({
  components: {
    ProviderDialog,
  },
  props: {
    popularGames: {
      type: Object as PropType<IThemePropertiesFromApi>,
      required: true,
    },
    newGames: {
      type: Object as PropType<IThemePropertiesFromApi>,
      required: true,
    },
    gameProviders: {
      type: Object as PropType<IThemePropertiesFromApi>,
      required: true,
    },
  },
  setup() {
    const popularGamesCount = computed(
      () =>
        gameStore.state.games.filter((game) => game.IsHotGame === true).length
    );
    const newGamesCount = computed(
      () =>
        gameStore.state.games.filter((game) => game.IsNewGame === true).length
    );
    const providers = computed(
      () => store.state.gameTabProviderList.SeamlessProviderList?.length
    );
    const dialogVisible = ref(false);
    return {
      popularGamesCount,
      newGamesCount,
      providers,
      dialogVisible,
    };
  },
});
</script>

<style>
.statistic {
  display: flex;
  flex-direction: row;
  align-items: center;
  padding: 8px;
  box-shadow: var(--box-shadow-inset);
  border-radius: 16px;
  background: var(--button-bg);
  height: 66px;
}
.statistic__count {
  text-align: center;
  font-size: 24px;
  line-height: 32px;
  height: 48px;
  margin: 0 20px 0 0;
  width: 92px;
  padding: 8px 16px;
  color: #eef0f6;
  font-weight: bold;
  background: linear-gradient(273.8deg, #d96331 15.88%, #e99018 98.99%);
  border-radius: 8px;
  margin-right: 20px;
}
.statistic h4 {
  font-size: 16px;
  line-height: 20px;
  margin-bottom: 6px;
  font-weight: bold;
  transition: color 0.4s;
  color: var(--title-font-color);
}
.see-all-link {
  align-items: center;
  font-weight: 600;
  font-size: 16px;
  line-height: 24px;
  text-transform: uppercase;
  text-decoration: none !important;
  display: flex;
}
</style>
